<template>
  <v-list-item
    icon
    dense
    :disabled="!analysis"
    @click="download"
  >
    <v-list-item-icon><v-icon>mdi-download</v-icon></v-list-item-icon>
    <v-list-item-title>
      {{ $t('button.download') }}
    </v-list-item-title>
  </v-list-item>
</template>

<script lang="ts">
import {
  Component, Prop, PropSync, Vue,
} from 'vue-property-decorator';
import type { Analysis } from '@/data';
import { showExport } from '@/components/dialogs';
import AnalysisParser from '@/formats/AnalysisParser';
import stringify from 'json-stringify-pretty-compact';

@Component({})
export default class ExportButton extends Vue {
  @Prop({ required: true })
  analysis!: Analysis | null;

  @PropSync('clean')
  isClean!: boolean;

  @Prop()
  piecePath!: string;

  getDefaultFileName(): string {
    const date = new Date().toLocaleDateString().replaceAll('/', '-');
    return `${this.piecePath}-analysis-${date}.dez`;
  }

  async download() {
    if (!this.analysis) {
      return;
    }

    const currentFilename = this.analysis.fileName || this.getDefaultFileName();

    // Update route
    const finalFilename = await showExport(currentFilename);

    if (!finalFilename) {
      return;
    }

    const obj = AnalysisParser.exportFormat(this.analysis);
    const txt = stringify(obj, {
      maxLength: 120,
      indent: 2,
    });
    const blob = new Blob([txt], { type: 'application/json' });
    const link = document.createElement('a');
    link.href = URL.createObjectURL(blob);
    link.download = finalFilename as string;
    link.click();
    URL.revokeObjectURL(link.href);
  }
}
</script>
